/**
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Roicenir Girardi Rostirolla ; Sérgio Luiz Heinzen
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais

 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */
package j2d;

import java.awt.Graphics;
import java.util.ArrayList;
import javax.swing.ImageIcon;

public class Logica {

    private Pecas[][] tabuleiro;
    private boolean jogadorDaVez;
    private ImageIcon rainha;
    private ArrayList<String> caminhos;

    public Logica(Pecas[][] tab) {
        this.tabuleiro = tab;
        this.jogadorDaVez = true;
        this.caminhos = new ArrayList<String>();


    }

    //percorre todas linhas e colunas em busca possiveis caminhos
    public ArrayList<String> procurarTodosCaminhos() {

        caminhos = new ArrayList<String>();

        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                if (tabuleiro[i][j] != null) {
                    if (tabuleiro[i][j].isCor() == jogadorDaVez) {
                        if (tabuleiro[i][j].isCor() == true) {
                            // o 1o. movimento das brancas é para cima
                            // tratar o 1o. movimento aqui para só depois invocar o percorreCaminho
                        } else {
                            //o 1o. movimento das pretas é para baixo
                        }
                        this.percorreCaminho(i, j, i, j, i + "" + j);
                    }
                }
            }
        }

        return caminhos;

    }

//executa todos os movimentos possiveis da peca realizar;
    public int mover(int ox, int oy, int dx, int dy) {
        if ((dy % 2 == 0) && (dx % 2 == 1) || (dy % 2 == 1) && (dx % 2 == 0)) {
            
            if (tabuleiro[oy][ox].isRainha() == true) {

                if ((dy == oy - 1 && dx == (ox + 1)) || (dy == (oy - 1) && dx == (ox - 1)) || (dy == (oy + 1) && dx == (ox - 1)) || (dy == (oy + 1) && dx == (ox + 1))) {


                    //Logica para Rainha comer pecas
                    /* if(((oy + 1) < 8) && (jogadorDaVez==false)){
                    if(((oy - 1) < 8) && (jogadorDaVez==true)){

                    if(tabuleiro[oy-1][ox-1]!=null){
                    if (dy == oy - 2 && dx == ox - 2) {
                    tabuleiro[oy - 2][ox - 2] = tabuleiro[oy][ox];
                    tabuleiro[oy - 1][ox - 1] = null;
                    this.jogadorDaVez = !this.jogadorDaVez;
                    }
                    return 0;

                    }

                    if(tabuleiro[oy+1][ox-1]!=null){
                    if (dy == oy + 2 && dx == ox - 2) {
                    tabuleiro[oy + 2][ox - 2] = tabuleiro[oy][ox];
                    tabuleiro[oy + 1][ox - 1] = null;
                    this.jogadorDaVez = !this.jogadorDaVez;
                    }
                    return 0;
                    }
                    if(tabuleiro[oy-1][ox+1]!=null){
                    if (dy == oy - 2 && dx == ox + 2) {
                    tabuleiro[oy - 2][ox + 2] = tabuleiro[oy][ox];
                    tabuleiro[oy - 1][ox + 1] = null;
                    this.jogadorDaVez = !this.jogadorDaVez;
                    }
                    return 0;
                    }
                    if(tabuleiro[oy+1][ox+1]!=null){
                    if (dy == oy + 2 && dx == ox + 2) {
                    tabuleiro[oy + 2][ox + 2] = tabuleiro[oy][ox];
                    tabuleiro[oy + 1][ox + 1] = null;
                    this.jogadorDaVez = !this.jogadorDaVez;
                    }
                    return 0;
                    }
                     */

                    this.jogadorDaVez = !this.jogadorDaVez;
                    return 0;
                } //         }
                // }
                else {
                    return 1;
                }
            }

            if (jogadorDaVez == false && dy == 7) {
                tabuleiro[oy][ox].setRainha(true);
            }

            if (jogadorDaVez == true && dy == 0) {
                tabuleiro[oy][ox].setRainha(true);
            }
            //Logica para obrigar a comer pecas
            if (caminhos.size() > 0) {

                if (jogadorDaVez == true) {
                    if ((ox + 1) < 8) {
                        if (tabuleiro[oy - 1][ox + 1] != null) {
                            if (dy == oy - 2 && dx == ox + 2) {
                                tabuleiro[oy - 2][ox + 2] = tabuleiro[oy][ox];
                                tabuleiro[oy - 1][ox + 1] = null;
                                this.jogadorDaVez = !this.jogadorDaVez;

                                int cont = 0;
                                cont++;

                                return 0;
                            } else {
                                return 1;
                            }
                        }
                    }

                    if (tabuleiro[oy - 1][ox - 1] != null) {
                        if (dy == oy - 2 && dx == ox - 2) {
                            tabuleiro[oy - 2][ox - 2] = tabuleiro[oy][ox];
                            tabuleiro[oy - 1][ox - 1] = null;
                            this.jogadorDaVez = !this.jogadorDaVez;

                            int cont2 = 0;
                            cont2++;

                            return 0;
                        } else {
                            return 1;
                        }
                    } else {
                        return 1;
                    }

                }
                if (jogadorDaVez == false) {

                    if (tabuleiro[oy + 1][ox - 1] != null) {
                        if (dy == oy + 2 && dx == ox - 2) {
                            tabuleiro[oy + 2][ox - 2] = tabuleiro[oy][ox];
                            tabuleiro[oy + 1][ox - 1] = null;
                            this.jogadorDaVez = !this.jogadorDaVez;

                            int cont3 = 0;
                            cont3++;

                            return 0;
                        } else {
                            return 1;
                        }
                    }

                    if ((ox + 1) > 8) {
                        if (tabuleiro[oy + 1][ox + 1] != null) {
                            if (dy == oy + 2 && dx == ox + 2) {
                                tabuleiro[oy + 2][ox + 2] = tabuleiro[oy][ox];
                                tabuleiro[oy + 1][ox + 1] = null;
                                this.jogadorDaVez = !this.jogadorDaVez;

                                int cont4 = 0;
                                cont4++;

                                return 0;
                            }
                        }
                    } else {
                        return 1;
                    }
                    return 0;
                } else {
                    return 1;
                }
            } else {

                //movimento de pecas
                if (jogadorDaVez == true) {

                    if ((dy == oy - 1 && dx == (ox + 1)) || (dy == (oy - 1) && dx == (ox - 1))) {
                        this.jogadorDaVez = !this.jogadorDaVez;
                        return 0;
                    }

                    if ((ox + 1) > 8) {
                        if (tabuleiro[oy - 1][ox + 1] != null) {
                            if (dy == oy - 2 && dx == ox + 2) {
                                tabuleiro[oy - 2][ox + 2] = tabuleiro[oy][ox];
                                tabuleiro[oy - 1][ox + 1] = null;
                                this.jogadorDaVez = !this.jogadorDaVez;

                                int cont = 0;
                                cont++;

                                return 0;
                            } else {
                                return 1;
                            }
                        }
                    }
                    if ((ox - 1) > 0) {

                        if (tabuleiro[oy - 1][ox - 1] != null) {
                            if (dy == oy - 2 && dx == ox - 2) {
                                tabuleiro[oy - 2][ox - 2] = tabuleiro[oy][ox];
                                tabuleiro[oy - 1][ox - 1] = null;
                                this.jogadorDaVez = !this.jogadorDaVez;

                                int cont2 = 0;
                                cont2++;

                                return 0;
                            } else {
                                return 1;
                            }
                        }

                    } else {
                        return 1;
                    }

                }
                if (jogadorDaVez == false) {
                    if ((dy == oy + 1 && dx == ox - 1) || (dy == oy + 1 && dx == ox + 1)) {
                        this.jogadorDaVez = !this.jogadorDaVez;
                        return 0;
                    }

                    if ((ox - 1) > -1) {
                        if (tabuleiro[oy + 1][ox - 1] != null) {
                            if (dy == oy + 2 && dx == ox - 2) {
                                tabuleiro[oy + 2][ox - 2] = tabuleiro[oy][ox];
                                tabuleiro[oy + 1][ox - 1] = null;
                                this.jogadorDaVez = !this.jogadorDaVez;

                                int cont3 = 0;
                                cont3++;

                                return 0;
                            } else {
                                return 1;
                            }
                        }
                    }

                    if ((ox + 1) < 8) {
                        if (tabuleiro[oy + 1][ox + 1] != null) {
                            if (dy == oy + 2 && dx == ox + 2) {
                                tabuleiro[oy + 2][ox + 2] = tabuleiro[oy][ox];
                                tabuleiro[oy + 1][ox + 1] = null;
                                this.jogadorDaVez = !this.jogadorDaVez;

                                int cont4 = 0;
                                cont4++;

                                return 0;
                            }
                        }
                    } else {
                        return 1;
                    }
                    return 0;
                } else {
                    return 1;
                }
            }

        } else {
            return 1;
        }

    }

    public void percorreCaminho(int antX, int antY, int xAtual, int yAtual, String anterior) {//calcula qual o maior caminho para
        //comer o maior numero de pecas adversarias;


        /* verificando direita acima */
        // garantindo que não ocorreu estouro dos limites da matriz e que não volte pela casa de onde veio
        if (((xAtual - 2 >= 0) && (yAtual + 2 <= 7)) && ((xAtual - 2 != antX) || (yAtual + 2 != antY))) {
            // verificando se é possível comer

            if (jogadorDaVez == true) {
                if ((tabuleiro[xAtual - 1][yAtual + 1] != null) && (tabuleiro[xAtual - 2][yAtual + 2] == null)) {
                    if ((tabuleiro[xAtual - 1][yAtual + 1].isCor() != jogadorDaVez)) {
                        // verificando se esta jogada não está presente no caminho percorrido até aqui
                        // proteção contra LOOP
                        if (!anterior.contains(xAtual + "" + yAtual + ":" + (xAtual - 2) + "" + (yAtual + 2))) {
                            // adicionando o caminho percorrido no arraylist
                            String novo = anterior + ":" + (xAtual - 2) + "" + (yAtual + 2);
                            caminhos.add(novo);
                            // será que deste ponto é possível capturar outra peça? vamos ver
                            this.percorreCaminho(xAtual, yAtual, xAtual - 2, yAtual + 2, novo);
                        } else {
                            // mensagem de depuração
                            System.err.println("teste  : " + xAtual + "" + yAtual + ":" + (xAtual - 2) + "" + (yAtual + 2));
                            System.err.println("caminho: " + anterior);
                        }
                    }

                }


                /* verificando direita abaixo */
                // garantindo que não ocorreu estouro dos limites da matriz e que não volte pela casa de onde veio
                if (((xAtual + 2 <= 7) && (yAtual + 2 <= 7)) && ((xAtual + 2 != antX) || (yAtual + 2 != antY))) {
                    // verificando se é possível comer
                    if ((tabuleiro[xAtual + 1][yAtual + 1] != null) && (tabuleiro[xAtual + 2][yAtual + 2] == null)) {
                        if ((tabuleiro[xAtual + 1][yAtual + 1].isCor() != jogadorDaVez)) {
                            // verificando se esta jogada não está presente no caminho percorrido até aqui
                            // proteção contra LOOP
                            if (!anterior.contains(xAtual + "" + yAtual + ":" + (xAtual + 2) + "" + (yAtual + 2))) {
                                // adicionando o caminho percorrido no arraylist
                                String novo = anterior + ":" + (xAtual + 2) + "" + (yAtual + 2);
                                caminhos.add(novo);
                                // será que deste ponto é possível capturar outra peça? vamos ver
                                this.percorreCaminho(xAtual, yAtual, xAtual + 2, yAtual + 2, novo);
                            } else {
                                // mensagem de depuração
                                System.err.println("teste  : " + xAtual + "" + yAtual + ":" + (xAtual + 2) + "" + (yAtual + 2));
                                System.err.println("caminho: " + anterior);
                            }
                        }
                    }

                }
            }
            if (jogadorDaVez == false) {

                // esquerda acima
                // garantindo que não ocorreu estouro dos limites da matriz e que não volte pela casa de onde veio
                if (((xAtual - 2 >= 0) && (yAtual - 2 >= 0)) && ((xAtual - 2 != antX) || (yAtual - 2 != antY))) {
                    // verificando se é possível comer
                    if ((tabuleiro[xAtual - 1][yAtual - 1] != null) && (tabuleiro[xAtual - 2][yAtual - 2] == null)) {
                        if ((tabuleiro[xAtual - 1][yAtual - 1].isCor() != jogadorDaVez)) {
                            // verificando se esta jogada não está presente no caminho percorrido até aqui
                            // proteção contra LOOP
                            if (!anterior.contains(xAtual + "" + yAtual + ":" + (xAtual - 2) + "" + (yAtual - 2))) {
                                // adicionando o caminho percorrido no arraylist
                                String novo = anterior + ":" + (xAtual - 2) + "" + (yAtual - 2);
                                caminhos.add(novo);
                                // será que deste ponto é possível capturar outra peça? vamos ver
                                this.percorreCaminho(xAtual, yAtual, xAtual - 2, yAtual - 2, novo);
                            } else {
                                //mensagem de depuração
                                System.err.println("teste  : " + xAtual + "" + yAtual + ":" + (xAtual - 2) + "" + (yAtual - 2));
                                System.err.println("caminho: " + anterior);
                            }

                        }
                    }
                }



                // esquerda abaixo
                // garantindo que não ocorreu estouro dos limites da matriz e que não volte pela casa de onde veio
                if (((xAtual + 2 <= 7) && (yAtual - 2 >= 0)) && ((xAtual + 2 != antX) || (yAtual - 2 != antY))) {
                    // verificando se é possível comer
                    if ((tabuleiro[xAtual + 1][yAtual - 1] != null) && (tabuleiro[xAtual + 2][yAtual - 2] == null)) {
                        if ((tabuleiro[xAtual + 1][yAtual - 1].isCor() != jogadorDaVez)) {
                            // verificando se esta jogada não está presente no caminho percorrido até aqui
                            // proteção contra LOOP
                            if (!anterior.contains(xAtual + "" + yAtual + ":" + (xAtual + 2) + "" + (yAtual - 2))) {
                                // adicionando o caminho percorrido no arraylist
                                String novo = anterior + ":" + (xAtual + 2) + "" + (yAtual - 2);
                                caminhos.add(novo);
                                // será que deste ponto é possível capturar outra peça? vamos ver
                                this.percorreCaminho(xAtual, yAtual, xAtual + 2, yAtual - 2, novo);
                            } else {
                                //mensagem de depuração
                                System.err.println("teste  : " + xAtual + "" + yAtual + ":" + (xAtual + 2) + "" + (yAtual - 2));
                                System.err.println("caminho: " + anterior);
                            }
                        }
                    }
                }
            }
        }
    }
}
